#include "monomial.h"

monomial::monomial()
{
    int i;
    this->c='k';
    this->ind=0;
    for(i=0;i<MAXMON;i++)
        this->mon[i]=0;
}
void monomial::cleanMonomial(){
    int i;
    this->c='k';
    this->ind=0;
    for(i=0;i<MAXMON;i++)
        this->mon[i]=0;
}
long double monomial::getIndependent(){
    return this->ind;
}
double monomial::getMonomial(int pos){
    return this->mon[pos];
}
void monomial::setIndependent(long double a){
    this->ind=this->ind+a;
}
void monomial::setMonomial(int pos,double value){
    this->mon[pos]=this->mon[pos]+value;
}
void monomial::printMonomialY(){
    printf("%LG",this->ind);
    int i;
    for(i=0;i<MAXMON;i++){
        if(this->mon[i]>0)
            printf("+%gY^%d",this->mon[i],i+1);
        else if(this->mon[i]<0)
            printf("%gY^%d",this->mon[i],i+1);
    }
    printf("\n");
}
void monomial::setFlag(char value){
    this->c=value;
}
char monomial::getFlag(){
    return this->c;
}
void monomial::printMonomialX(){
    printf("%LG",this->ind);
    int i;
    for(i=0;i<MAXMON;i++){
        if(this->mon[i]>0)
            printf("+%gX^%d",this->mon[i],i+1);
        else if(this->mon[i]<0)
            printf("%gX^%d",this->mon[i],i+1);
    }
    printf("\n");
}
void monomial::printMonomialXInFile(FILE * f){
    fprintf(f,"%LG",this->ind);
    int i;
    for(i=0;i<MAXMON;i++){
        if(this->mon[i]>0)
            fprintf(f,"+%gX^%d",this->mon[i],i+1);
        else if(this->mon[i]<0)
            fprintf(f,"%gX^%d",this->mon[i],i+1);
    }
    fprintf(f,"\n");
}

void monomial::printMonomialYInFile(FILE * f){
    fprintf(f,"%LG",this->ind);
    int i;
    for(i=0;i<MAXMON;i++){
        if(this->mon[i]>0)
            fprintf(f,"+%gY^%d",this->mon[i],i+1);
        else if(this->mon[i]<0)
            fprintf(f,"%gY^%d",this->mon[i],i+1);
    }
    fprintf(f,"\n");
}
